summaryrefslogtreecommitdiff
path: root/test/TEST-11-LVM/test.sh
diff options
context:
space:
mode:
Diffstat (limited to 'test/TEST-11-LVM/test.sh')
-rwxr-xr-xtest/TEST-11-LVM/test.sh76
1 files changed, 76 insertions, 0 deletions
diff --git a/test/TEST-11-LVM/test.sh b/test/TEST-11-LVM/test.sh
new file mode 100755
index 0000000..19d72aa
--- /dev/null
+++ b/test/TEST-11-LVM/test.sh
@@ -0,0 +1,76 @@
+#!/bin/bash
+TEST_DESCRIPTION="root filesystem on LVM PV"
+
+KVERSION=${KVERSION-$(uname -r)}
+
+# Uncomment this to debug failures
+#DEBUGFAIL="rdinitdebug rdnetdebug"
+
+test_run() {
+ $testdir/run-qemu -hda root.ext2 -m 256M -nographic \
+ -net none -kernel /boot/vmlinuz-$KVERSION \
+ -append "root=/dev/dracut/root rw quiet console=ttyS0,115200n81 rdshell $DEBUGFAIL" \
+ -initrd initramfs.testing
+ grep -m 1 -q dracut-root-block-success root.ext2 || return 1
+}
+
+test_setup() {
+ # Create the blank file to use as a root filesystem
+ dd if=/dev/zero of=root.ext2 bs=1M count=20
+
+ kernel=$KVERSION
+ # Create what will eventually be our root filesystem onto an overlay
+ (
+ initdir=overlay/source
+ . $basedir/dracut-functions
+ dracut_install sh df free ls shutdown poweroff stty cat ps ln ip route \
+ /lib/terminfo/l/linux mount dmesg ifconfig dhclient mkdir cp ping dhclient
+ inst "$basedir/modules.d/40network/dhclient-script" "/sbin/dhclient-script"
+ inst "$basedir/modules.d/40network/ifup" "/sbin/ifup"
+ dracut_install grep
+ inst ./test-init /sbin/init
+ find_binary plymouth >/dev/null && dracut_install plymouth
+ (cd "$initdir"; mkdir -p dev sys proc etc var/run tmp )
+ )
+
+ # second, install the files needed to make the root filesystem
+ (
+ initdir=overlay
+ . $basedir/dracut-functions
+ dracut_install sfdisk mke2fs poweroff cp umount
+ inst_simple ./create-root.sh /initqueue/01create-root.sh
+ )
+
+ # create an initramfs that will create the target root filesystem.
+ # We do it this way so that we do not risk trashing the host mdraid
+ # devices, volume groups, encrypted partitions, etc.
+ $basedir/dracut -l -i overlay / \
+ -m "dash lvm mdraid udev-rules base rootfs-block kernel-modules" \
+ -d "ata_piix ext2 sd_mod" \
+ -f initramfs.makeroot $KVERSION || return 1
+ rm -rf overlay
+ # Invoke KVM and/or QEMU to actually create the target filesystem.
+ $testdir/run-qemu -hda root.ext2 -m 256M -nographic -net none \
+ -kernel "/boot/vmlinuz-$kernel" \
+ -append "root=/dev/dracut/root rw rootfstype=ext2 quiet console=ttyS0,115200n81" \
+ -initrd initramfs.makeroot || return 1
+ grep -m 1 -q dracut-root-block-created root.ext2 || return 1
+ (
+ initdir=overlay
+ . $basedir/dracut-functions
+ dracut_install poweroff shutdown
+ inst_simple ./hard-off.sh /emergency/01hard-off.sh
+ )
+ sudo $basedir/dracut -l -i overlay / \
+ -o "plymouth" \
+ -a "debug" \
+ -d "ata_piix ext2 sd_mod" \
+ -f initramfs.testing $KVERSION || return 1
+}
+
+test_cleanup() {
+ rm -fr overlay mnt
+ rm -f root.ext2 initramfs.makeroot initramfs.testing
+}
+
+. $testdir/test-functions